import time

from argparse import ArgumentParser
from pymavlink import mavutil

parser = ArgumentParser(description=__doc__)
parser.add_argument("connection", type=str)
args = parser.parse_args()

connection = mavutil.mavlink_connection(args.connection)
interval = 1
last_sent_timesync = 0
last_sent_ts1 = 0
timeout = interval

while True:

    now = time.time()

    if (now - last_sent_timesync > interval):
        # send TIMESYNC/PING request
        last_sent_timesync = now
        time_ns = now * 10**9
        connection.mav.timesync_send(0, int(time_ns))
        last_sent_ts1 = time_ns


    message = connection.recv_match(type='TIMESYNC')
    if message is None:
        continue
    elif message.get_type() == 'TIMESYNC':
        if message.tc1 != 0 and message.ts1 == last_sent_ts1:
            # we received a response to our last timesync request
            now_ns = time.time() * 10**9
            rtt  = (now_ns - last_sent_ts1) / 10**6
            print(
                    "ST: timesync response: sysid=%u latency=%fms" % (message.get_srcSystem(), rtt)
                  )

